from ml.ml40.features.properties.values.value import Value


class FlapOpened(Value):
    __opened: bool

    def __init__(self, namespace="cml40", name="", identifier="", parent=None):
        super().__init__(
            namespace=namespace,
            name=name,
            identifier=identifier,
            parent=parent
        )

        self.__opened = False
        self.__json_out = dict()

    @property
    def opened(self):
        return self.__opened

    @opened.setter
    def opened(self, value):
        self.__opened = value

    def to_json(self):
        self.__json_out = super().to_json()
        if self.__opened is not None:
            self.__json_out["opened"] = self.__opened
        return self.__json_out
