from ml.ml40.features.properties.values.value import Value


class MobilePlatformLoaded(Value):

    __loaded: bool
    __thingId:  str

    def __init__(self, namespace="cml40", name="", identifier="", parent=None):
        super().__init__(
            namespace=namespace,
            name=name,
            identifier=identifier,
            parent=parent
        )

        self.__loaded = False
        self.__thingId = ""
        self.__json_out = dict()

    @property
    def attached(self):
        return self.__loaded

    @attached.setter
    def attached(self, value):
        self.__loaded = value

    @property
    def thingId(self):
        return self.__thingId

    @thingId.setter
    def thingId(self, value):
        self.__thingId = value

    def to_json(self):
        self.__json_out = super().to_json()
        if self.__loaded is not None:
            self.__json_out["loaded"] = self.__loaded
        if self.__thingId is not None:
            self.__json_out["thingId"] = self.__thingId

        return self.__json_out

