from ml.ml40.features.properties.values.value import Value


class MobilePlatformTransportBoxAttached(Value):

    __attached: bool
    __thingId:  str

    def __init__(self, namespace="cml40", name="", identifier="", parent=None):
        super().__init__(
            namespace=namespace,
            name=name,
            identifier=identifier,
            parent=parent
        )

        self.__attached = False
        self.__thingId = ""
        self.__json_out = dict()

    @property
    def attached(self):
        return self.__attached

    @attached.setter
    def attached(self, value):
        self.__attached = value

    @property
    def thingId(self):
        return self.__thingId

    @thingId.setter
    def thingId(self, value):
        self.__thingId = value

    def to_json(self):
        self.__json_out = super().to_json()
        if self.__attached is not None:
            self.__json_out["attached"] = self.__attached
        if self.__thingId is not None:
            self.__json_out["thingId"] = self.__thingId

        return self.__json_out

