from ml.ml40.features.properties.values.value import Value


class ScaffoldStructure(Value):
    __currentState: dict
    __targetState: dict

    def __init__(self, namespace="cml40", name="", identifier="", parent=None):
        super().__init__(
            namespace=namespace,
            name=name,
            identifier=identifier,
            parent=parent
        )

        self.__currentState = {}
        self.__targetState = {}
        self.__json_out = dict()

    @property
    def currentState(self):
        return self.__currentState

    @currentState.setter
    def currentState(self, value):
        self.__currentState = value

    @property
    def targetState(self):
        return self.__targetState

    @targetState.setter
    def targetState(self, value):
        self.__targetState = value

    def to_json(self):
        self.__json_out = super().to_json()
        if self.__currentState is not None:
            self.__json_out["currentState"] = self.__currentState
        if self.__targetState is not None:
            self.__json_out["targetState"] = self.__targetState

        return self.__json_out
