from ml.ml40.features.properties.values.value import Value


class OrientationQuaternion(Value):
    def __init__(self, namespace="ml40", name="", identifier="", parent=None):
        super().__init__(
            namespace=namespace,
            name=name,
            identifier=identifier,
            parent=parent
        )

        self.__qx = None
        self.__qy = None
        self.__qz = None
        self.__qw = None
        self.__json_out = dict()

    @property
    def qx(self):
        return self.__qx

    @qx.setter
    def qx(self, value):
        self.__qx = value

    @property
    def qy(self):
        return self.__qy

    @qy.setter
    def qy(self, value):
        self.__qy = value

    @property
    def qz(self):
        return self.__qz

    @qz.setter
    def qz(self, value):
        self.__qz = value

    @property
    def qw(self):
        return self.__qw

    @qw.setter
    def qw(self, value):
        self.__qw = value

    def to_json(self):
        self.__json_out = super().to_json()
        if self.__qx is not None:
            self.__json_out["qx"] = self.__qx
        if self.__qy is not None:
            self.__json_out["qy"] = self.__qy
        if self.__qz is not None:
            self.__json_out["qz"] = self.__qz
        if self.__qw is not None:
            self.__json_out["qw"] = self.__qw

        return self.__json_out

