from ml.ml40.features.properties.values.value import Value
from ml.ml40.features.properties.values.position import Position
from ml.ml40.features.properties.values.orientation_quaternion import OrientationQuaternion


class Pose(Value):
    def __init__(self, namespace="ml40", name="", identifier="", parent=None):
        super().__init__(
            namespace=namespace,
            name=name,
            identifier=identifier,
            parent=parent
        )

        self.__position = None
        self.__orientation = None
        self.__json_out = dict()

    @property
    def position(self):
        return self.__position

    @position.setter
    def position(self, value: Position):
        self.__position = value

    @property
    def orientation(self):
        return self.orientation

    @orientation.setter
    def orientation(self, value: OrientationQuaternion):
        self.orientation = value

    def to_json(self):
        self.__json_out = super().to_json()
        if self.__position is not None:
            self.__json_out["position"] = self.__position
        if self.__orientation is not None:
            self.__json_out["orientation"] = self.__orientation

        return self.__json_out
