from ml.ml40.features.properties.values.value import Value


class Position(Value):
    def __init__(self, namespace="ml40", name="", identifier="", parent=None):
        super().__init__(
            namespace=namespace,
            name=name,
            identifier=identifier,
            parent=parent
        )

        self.__x = None
        self.__y = None
        self.__z = None
        self.__json_out = dict()

    @property
    def x(self):
        return self.__x

    @x.setter
    def x(self, value):
        self.__x = value

    @property
    def y(self):
        return self.__y

    @y.setter
    def y(self, value):
        self.__y = value

    @property
    def z(self):
        return self.__z

    @z.setter
    def z(self, value):
        self.__z = value


    def to_json(self):
        self.__json_out = super().to_json()
        if self.__x is not None:
            self.__json_out["x"] = self.__x
        if self.__y is not None:
            self.__json_out["y"] = self.__y
        if self.__z is not None:
            self.__json_out["z"] = self.__z

        return self.__json_out

