"""This module implements the class AcceptsPlaceJob."""
from ml.rml40.features.properties.values.documents.jobs.robot_pick_job import RobotPickJob
from ml.ml40.features.functionalities.accepts_jobs import AcceptsJobs
from ml.ml40.features.properties.values.documents.jobs.job_status import JobStatus


class AcceptsPickJobs(AcceptsJobs):
    """This functionality signalizes that PickJob can be processed and
    offers the possibility to remove and query it."""

    def __init__(self, namespace="rml40", name="", identifier="", parent=None):
        """Initializes the object.

        :param name: Object name
        :param identifier: Identifier

        """
        super().__init__(
            namespace=namespace, name=name, identifier=identifier, parent=parent
        )

    async def acceptJob(self, job: RobotPickJob) -> bool:
        """Accepts the given RobotPick job. Returns true if the job has been
        accepted, otherwise returns false.

        :param job: RobotPickJob to be accepted
        :rtype: bool

        """
        pass

    async def queryJobStatus(self, identifier) -> JobStatus:
        """Returns the partTypeId of the job whose id is identical to identifier.

        :param identifier: Identifier of the job to be queried
        :returns: Status of the job
        :rtype: JobStatus

        """
        pass

    async def removeJob(self, identifier) -> bool:
        """Removes the job with the id identical to identifier. Returns true
        if the job has been removed, otherwise returns false.

        :param identifier: Identifier of the job to be deleted
        :rtype: bool

        """
        pass
