from ml.ml40.features.properties.values.documents.jobs.job import Job
from ml.rml40.features.properties.values.joint_positions import JointPositions


class MoveToJointPositionsJob(Job):
    def __init__(self, namespace="rml40", name="", identifier=""):
        super().__init__(namespace=namespace, name=name, identifier=identifier)
        self.__constraints = None
        self.__goalPositions = None
        self.__json_out = dict()

    @property
    def goalConfiguration(self):
        return self.__goalPositions

    @goalConfiguration.setter
    def goalConfiguration(self, value: JointPositions):
        self.__goalPositions = value

    @property
    def constraints(self):
        return self.__goalPositions

    @constraints.setter
    def constraints(self, value):
        self.__constraints = value

    def to_json(self):
        self.__json_out = super().to_json()
        if self.__goalPositions is not None:
            self.__json_out["goalPositions"] = self.__goalPositions
        if self.__constraints is not None:
            self.__json_out["constraints"] = self.__constraints
        return self.__json_out
