from ml.ml40.features.properties.values.documents.jobs.job import Job
from ml.ml40.features.properties.values.pose import Pose


class MoveToPoseJob(Job):
    def __init__(self, namespace="rml40", name="", identifier=""):
        super().__init__(namespace=namespace, name=name, identifier=identifier)
        self.__constraints = None
        self.__goalPose = None
        self.__json_out = dict()

    @property
    def goalPose(self):
        return self.__goalPose

    @goalPose.setter
    def goalPose(self, value: Pose):
        self.__goalPose = value

    @property
    def constraints(self):
        return self.__constraints

    @constraints.setter
    def constraints(self, value: dict):
        self.__constraints = value

    def to_json(self):
        self.__json_out = super().to_json()
        if self.__goalPose is not None:
            self.__json_out["goalPose"] = self.__goalPose
        if self.__constraints is not None:
            self.__json_out["constraints"] = self.__constraints
        return self.__json_out
