from ml.cml40.features.properties.values.documents.jobs.mount_job import MountJob
from ml.ml40.features.properties.values.pose import Pose


class RobotMountJob(MountJob):
    def __init__(self, namespace="rml40", name="", identifier=""):
        super().__init__(namespace=namespace, name=name, identifier=identifier)
        self.__constraints = None
        self.__hoverPose = None
        self.__mountPose = None
        self.__json_out = dict()

    @property
    def mountPose(self):
        return self.__mountPose

    @mountPose.setter
    def mountPose(self, value: Pose):
        self.__mountPose = value

    @property
    def hoverPose(self):
        return self.__hoverPose

    @hoverPose.setter
    def hoverPose(self, value: Pose):
        self.__hoverPose = value

    @property
    def constraints(self):
        return self.__mountPose

    @constraints.setter
    def constraints(self, value):
        self.__constraints = value

    def to_json(self):
        self.__json_out = super().to_json()
        if self.__mountPose is not None:
            self.__json_out["mountPose"] = self.__mountPose
        if self.__hoverPose is not None:
            self.__json_out["hoverPose"] = self.__hoverPose
        if self.__constraints is not None:
            self.__json_out["constraints"] = self.__constraints
        return self.__json_out
