from ml.ml40.features.properties.values.documents.jobs.pick_job import PickJob
from ml.ml40.features.properties.values.pose import Pose


class RobotPickJob(PickJob):
    def __init__(self, namespace="rml40", name="", identifier=""):
        super().__init__(namespace=namespace, name=name, identifier=identifier)
        self.__constraints = None
        self.__hoverPose = None
        self.__pickPose = None
        self.__json_out = dict()

    @property
    def pickPose(self):
        return self.__pickPose

    @pickPose.setter
    def pickPose(self, value: Pose):
        self.__pickPose = value

    @property
    def hoverPose(self):
        return self.__hoverPose

    @pickPose.setter
    def hoverPose(self, value: Pose):
        self.__hoverPose = value

    @property
    def constraints(self):
        return self.__pickPose

    @constraints.setter
    def constraints(self, value):
        self.__constraints = value

    def to_json(self):
        self.__json_out = super().to_json()
        if self.__pickPose is not None:
            self.__json_out["pickPose"] = self.__pickPose
        if self.__hoverPose is not None:
            self.__json_out["hoverPose"] = self.__hoverPose
        if self.__constraints is not None:
            self.__json_out["constraints"] = self.__constraints
        return self.__json_out
