from ml.ml40.features.properties.values.documents.jobs.place_job import PlaceJob
from ml.ml40.features.properties.values.pose import Pose


class RobotPlaceJob(PlaceJob):
    def __init__(self, namespace="rml40", name="", identifier=""):
        super().__init__(namespace=namespace, name=name, identifier=identifier)
        self.__constraints = None
        self.__hoverPose = None
        self.__placePose = None
        self.__json_out = dict()

    @property
    def placePose(self):
        return self.__placePose

    @placePose.setter
    def placePose(self, value: Pose):
        self.__placePose = value

    @property
    def hoverPose(self):
        return self.__hoverPose

    @placePose.setter
    def hoverPose(self, value: Pose):
        self.__hoverPose = value

    @property
    def constraints(self):
        return self.__placePose

    @constraints.setter
    def constraints(self, value):
        self.__constraints = value

    def to_json(self):
        self.__json_out = super().to_json()
        if self.__placePose is not None:
            self.__json_out["placePose"] = self.__placePose
        if self.__hoverPose is not None:
            self.__json_out["hoverPose"] = self.__hoverPose
        if self.__constraints is not None:
            self.__json_out["constraints"] = self.__constraints
        return self.__json_out
