from ml.ml40.features.properties.values.value import Value


class GraspingStatus(Value):

    __grasped: bool

    def __init__(self, namespace="rml40", name="", identifier="", parent=None):
        super().__init__(
            namespace=namespace,
            name=name,
            identifier=identifier,
            parent=parent
        )

        self.__grasped = False
        self.__json_out = dict()

    @property
    def grasped(self):
        return self.__grasped

    @grasped.setter
    def grasped(self, value):
        self.__grasped = value

    def to_json(self):
        self.__json_out = super().to_json()
        if self.__grasped is not None:
            self.__json_out["grasped"] = self.__grasped
        return self.__json_out

