from ml.ml40.features.properties.values.value import Value


class MovementStatus(Value):

    __moving: bool

    def __init__(self, namespace="rml40", name="", identifier="", parent=None):
        super().__init__(
            namespace=namespace,
            name=name,
            identifier=identifier,
            parent=parent
        )

        self.__moving = False
        self.__json_out = dict()

    @property
    def moving(self):
        return self.__moving

    @moving.setter
    def moving(self, value):
        self.__moving = value

    def to_json(self):
        self.__json_out = super().to_json()
        if self.__moving is not None:
            self.__json_out["moving"] = self.__moving

        return self.__json_out

