from ml.ml40.features.properties.values.value import Value


class PowerStatus(Value):

    __running: bool

    def __init__(self, namespace="rml40", name="", identifier="", parent=None):
        super().__init__(
            namespace=namespace,
            name=name,
            identifier=identifier,
            parent=parent
        )

        self.__running = False
        self.__json_out = dict()

    @property
    def running(self):
        return self.__running

    @running.setter
    def running(self, value):
        self.__running = value

    def to_json(self):
        self.__json_out = super().to_json()
        if self.__running is not None:
            self.__json_out["running"] = self.__running

        return self.__json_out

